import { useState, createRef, useEffect, createElement } from 'react';
import styled from 'styled-components';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

/**
 * @class AsyncSearch
 */
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  background-color: #fff;\n  height: 31px;\n  position: relative;\n  border-radius: 3px;\n  border: 1px solid rgba(208, 211, 212, 0.7);\n  width: 160px;\n  /*Removes the default x on input field in ie11*/\n  input[type='search']::-ms-clear {\n    display: none;\n    width: 0;\n    height: 0;\n  }\n  input[type='search']::-ms-reveal {\n    display: none;\n    width: 0;\n    height: 0;\n  }\n\n  /* clears the 'X' from Chrome */\n  input[type='search']::-webkit-search-decoration,\n  input[type='search']::-webkit-search-cancel-button,\n  input[type='search']::-webkit-search-results-button,\n  input[type='search']::-webkit-search-results-decoration {\n    display: none;\n  }\n  &:hover {\n    cursor: text;\n  }\n  transition: box-shadow 0.2s ease-in-out;\n"], ["\n  display: flex;\n  background-color: #fff;\n  height: 31px;\n  position: relative;\n  border-radius: 3px;\n  border: 1px solid rgba(208, 211, 212, 0.7);\n  width: 160px;\n  /*Removes the default x on input field in ie11*/\n  input[type='search']::-ms-clear {\n    display: none;\n    width: 0;\n    height: 0;\n  }\n  input[type='search']::-ms-reveal {\n    display: none;\n    width: 0;\n    height: 0;\n  }\n\n  /* clears the 'X' from Chrome */\n  input[type='search']::-webkit-search-decoration,\n  input[type='search']::-webkit-search-cancel-button,\n  input[type='search']::-webkit-search-results-button,\n  input[type='search']::-webkit-search-results-decoration {\n    display: none;\n  }\n  &:hover {\n    cursor: text;\n  }\n  transition: box-shadow 0.2s ease-in-out;\n"])));
var Input = styled.input(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  border: none;\n  color: #333;\n  font-family: Lato, sans-serif;\n  font-size: 14px;\n  background-color: #fff;\n  border-radius: 3px;\n  width: 75%;\n  margin-left: 0.5em;\n  -webkit-appearance: none;\n  -webkit-moz-appearance: none;\n  appearance: none;\n  font-weight: bold;\n  &:focus:enabled {\n    outline: none;\n  }\n"], ["\n  border: none;\n  color: #333;\n  font-family: Lato, sans-serif;\n  font-size: 14px;\n  background-color: #fff;\n  border-radius: 3px;\n  width: 75%;\n  margin-left: 0.5em;\n  -webkit-appearance: none;\n  -webkit-moz-appearance: none;\n  appearance: none;\n  font-weight: bold;\n  &:focus:enabled {\n    outline: none;\n  }\n"])));
var RemoveButton = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  margin-right: 4px;\n  margin-left: 4px;\n\n  &:hover {\n    cursor: pointer;\n  }\n"], ["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  margin-right: 4px;\n  margin-left: 4px;\n\n  &:hover {\n    cursor: pointer;\n  }\n"])));
var Popover = styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  position: absolute;\n  box-sizing: border-box;\n  border-radius: 3px;\n  box-shadow: 0 2px 7px 0 rgba(0, 0, 0, 0.1);\n  padding: 0.5em;\n  z-index: 3;\n  top: 38px;\n  min-width: 160px;\n  max-height: 25em;\n  width: max-content;\n  max-width: 20em;\n  overflow-y: auto;\n  background-color: #fff;\n  //transition: 1s ease-in-out;\n"], ["\n  position: absolute;\n  box-sizing: border-box;\n  border-radius: 3px;\n  box-shadow: 0 2px 7px 0 rgba(0, 0, 0, 0.1);\n  padding: 0.5em;\n  z-index: 3;\n  top: 38px;\n  min-width: 160px;\n  max-height: 25em;\n  width: max-content;\n  max-width: 20em;\n  overflow-y: auto;\n  background-color: #fff;\n  //transition: 1s ease-in-out;\n"])));
var ListDiv = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  padding: 0.5em;\n  align-items: center;\n  display: flex;\n  font-size: 14px;\n  font-family: Lato, sans-serif;\n  border-bottom: 1px solid grey;\n"], ["\n  padding: 0.5em;\n  align-items: center;\n  display: flex;\n  font-size: 14px;\n  font-family: Lato, sans-serif;\n  border-bottom: 1px solid grey;\n"])));
var SearchIcon = styled.div(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  color: rgb(255, 92, 57);\n  display: flex;\n  align-items: center;\n  margin-left: 4px;\n  margin-right: 4px;\n  font-size: 18px;\n  -webkit-transform: rotate(45deg);\n  -moz-transform: rotate(-45deg);\n  -o-transform: rotate(-45deg);\n  transform: rotate(-45deg);\n"], ["\n  color: rgb(255, 92, 57);\n  display: flex;\n  align-items: center;\n  margin-left: 4px;\n  margin-right: 4px;\n  font-size: 18px;\n  -webkit-transform: rotate(45deg);\n  -moz-transform: rotate(-45deg);\n  -o-transform: rotate(-45deg);\n  transform: rotate(-45deg);\n"])));
var AsyncSearchDropdown = function (props) {
    var containerRef;
    var popoverRef;
    var timeOutId = null;
    var _a = useState(''), searchValue = _a[0], setSearchValue = _a[1];
    containerRef = createRef();
    popoverRef = createRef();
    var _b = useState([]), items = _b[0], setItems = _b[1];
    var _c = useState(false), isPopoverOpen = _c[0], setPopoverState = _c[1];
    var _d = useState(-1), hoveredIndex = _d[0], sethoveredIndex = _d[1];
    var _e = useState(props.placeholder), lastSelectedItem = _e[0], setLastSelectedItem = _e[1];
    var _f = useState([]), selectedItems = _f[0], setSelectedItems = _f[1];
    useEffect(function () {
        document.addEventListener('keyup', handleKeyPress);
        return function () {
            document.removeEventListener('keyup', handleKeyPress);
        };
    });
    function handleKeyPress(e) {
        if (e.which === 38) {
            if (hoveredIndex > 0) {
                sethoveredIndex(function (c) { return c - 1; });
            }
        }
        else if (e.which === 40) {
            if (hoveredIndex < items.length - 1) {
                sethoveredIndex(function (c) { return c + 1; });
            }
        }
        else if (e.which === 13) {
            if (isPopoverOpen && hoveredIndex > -1) {
                var selectedItem = items[hoveredIndex];
                handleClickItem(selectedItem, hoveredIndex);
            }
        }
        else if (e.which === 27) {
            setPopoverState(false);
        }
    }
    function handleClickItem(item, index) {
        // check if item is already selected
        var isSelected2 = false;
        selectedItems.forEach(function (t) {
            if (t.id === item.id) {
                isSelected2 = true;
            }
        });
        /* creates a shallow copy of the selected items, then it pushes the new object into
           the copy. After that it runs the setSelectedItems hook with the copy as value
        */
        if (isSelected2) {
            var temp = selectedItems.slice();
            var indexToRemove = temp.findIndex(function (tempValue) {
                return tempValue.id === item.id;
            });
            temp.splice(indexToRemove, 1);
            setSelectedItems(temp);
            props.onChange(temp);
        }
        else {
            var copy = selectedItems.slice();
            copy.push(item);
            setSelectedItems(copy);
            // Changes the placeholder text to the items that are chosen
            if (copy.length > 1) {
                setLastSelectedItem(function (c) { return c + '...' + item.label; });
            }
            else {
                setLastSelectedItem(item.label);
            }
            // Empties the input's value, dispatches an onChange event, and closes the popover
            setSearchValue('');
            props.onChange(copy);
            sethoveredIndex(-1);
        }
        onBlurHandler();
    }
    function handleSearchChange(e) {
        e.persist();
        setSearchValue(e.target.value);
        if (searchValue.length > 1) {
            setPopoverState(true);
        }
        else {
            setPopoverState(false);
        }
        props.getItems(e.target.value).then(function (result) {
            setItems(result);
        });
    }
    function clearAllItems() {
        setSelectedItems([]);
        setLastSelectedItem('');
        setSearchValue('');
        props.onChange([]);
    }
    function onBlurHandler() {
        timeOutId = setTimeout(function () {
            setPopoverState(false);
        }, 200);
    }
    return (createElement(Container, { style: props.style, ref: containerRef, onBlur: function () { return onBlurHandler(); }, onFocus: function () {
            if (searchValue.length > 2) {
                setPopoverState(true);
            }
        } },
        props.leftIcon && createElement(SearchIcon, null, "\u26B2"),
        createElement(Input, { type: "search", value: searchValue, onChange: function (e) { return handleSearchChange(e); }, placeholder: lastSelectedItem || props.placeholder || 'Search here...' }),
        props.canClearAll && (createElement(RemoveButton, { onClick: function () { return clearAllItems(); } }, "\u2715")),
        isPopoverOpen && (createElement(Popover, { ref: popoverRef, onBlur: function () { return onBlurHandler(); }, onClick: function (e) {
                clearTimeout(timeOutId);
            } },
            items.length === 0 && (createElement("div", { style: {
                    display: 'flex',
                    fontFamily: 'Lato,sans-serif',
                    fontSize: '14px',
                    fontWeight: 'bold',
                    justifyContent: 'center',
                } }, props.noResultMessage || 'No result...')),
            items.map(function (c, i) {
                var isActive = hoveredIndex === i;
                var isSelected = false;
                selectedItems.forEach(function (t) {
                    if (t.id === c.id) {
                        isSelected = true;
                    }
                });
                return (createElement("div", { onMouseEnter: function () {
                        sethoveredIndex(i);
                    }, onMouseLeave: function () {
                        sethoveredIndex(-1);
                    }, key: i, onClick: function () {
                        handleClickItem(c, i);
                    } },
                    !props.defaultListStyling &&
                        props.renderItem &&
                        props.renderItem(c, i, isActive, isSelected, c.img),
                    props.defaultListStyling && (createElement(ListDiv, { style: {
                            backgroundColor: isActive ? '#00B0B9' : '#fff',
                            cursor: isActive ? 'pointer' : 'normal',
                        } },
                        createElement("div", { style: {
                                height: '1.6em',
                                fontSize: '18px',
                                color: isSelected ? 'red' : 'grey',
                                marginRight: '.5em',
                            } }, "\u2713"),
                        c.label))));
            })))));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;

export { AsyncSearchDropdown };
//# sourceMappingURL=index.es.js.map
